<script type="text/html" data-help-name="dim-xml-cmd-client">
  <p>
    A DIM-XML Client node for triggering a command service on a DIM Service
    Provider (DIS) and receiving an acknowledgement.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>
      payload
      <span class="property-type">string | number | boolean | object</span>
    </dt>
    <dd>
      The command to send.<br>
      When the input is not a JavaScript object, it is converted into string
      and sent as the value of <code>$textContent</code> property inside an
      object; whereas an input object may have the <code>$textContent</code>
      property to attach any text content to the command.<br>
      If this property is not set, no command will be sent.
    </dd>
  </dl>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">string</span></dt>
    <dd>The text content of the command acknowlegment.</dd>
    <dt class="optional">key<span class="property-type">number</span></dt>
    <dd>
      An optional integer used for matching acknowledgements with commands.
    </dd>
    <dt>error<span class="property-type">number</span></dt>
    <dd>An integer defining the command error code.</dd>
    <dt>status<span class="property-type">number</span></dt>
    <dd>An integer defining the command status.</dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node must be configured with the name of the service to which commands
    are to be sent and a connection to the DIM Name Server (DNS) hosting that
    service. For the latter, it is possible to either create a new DNS Server
    connection by clicking on the pencil icon or use an existing one shared
    between several DIM-XML nodes.
  </p>
  <p>
    The node can retrieve the list of the <i>Command/Acknowledge</i> services
    registered on the DNS Server set-up.
  </p>
  <p>
    The successful execution of a command produces an output (acknowledgement)
    with <code>error</code> and <code>status</code> properties set to <b>0</b>
    and <b>2</b> respectively, and an eventual message in <code>payload</code>.
    If the command fails, <code>error</code> and <code>payload</code>
    properties should reflect the error and <code>status</code> is set to
    <b>3</b>. Namely:
  </p>
  <p>
    <table style="outline-width:#888 solid thin">
      <tr style="background-color:#f8f8f8">
        <th width="50px">Command</th>
        <th width="50px">Status</th>
        <th width="50px">Error</th>
        <th width="80px">Payload</th>
      </tr>
      <tr style="background-color:#e8e8e8">
        <td><center>SUCCESSFUL</center></td>
        <td><center><i>2</i></center></td>
        <td><center><i>0</i></center></td>
        <td><center><i>success msg</i></center></td>
      </tr>
      <tr style="background-color:#f8f8f8">
        <td><center>FAILED</center></td>
        <td><center><i>3</i></center></td>
        <td><center><i>error code</i></center></td>
        <td><center><i>error msg</i></center></td>
      </tr>
    </table>
  </p>
  <p>
    <b>Note</b>: An error is raised if the command's acknowledgement is not
    received within <i>Timeout</i> milliseconds. By default, it is 1000 ms.
  </p>
</script>
